# gpg_key

## Properties

| Property                   | Ruby Type        | Default                                | Description                                                                                                |
| -------------------------- | ---------------- | -------------------------------------- | ---------------------------------------------------------------------------------------------------------- |
| `batch_name`               | String           |                                        | Name of  the key/batch to generate.                                                                        |
| `override_default_keyring` | [true, false]    | `false`                                | Set to true if you want to override the pubring_file and secring_file locations.                           |
| `pubring_file`             | String           |                                        | Public keyring file location (override_default_keyring must be set to true or this option will be ignored) |
| `secring_file`             | String           |                                        | Secret keyring file location (override_default_keyring must be set to true or this option will be ignored) |
| `user`                     | String           | `root`                                 | User to generate the key for                                                                               |
| `group`                    | String           | `user`                                 | Group to run the generate command as                                                                       |
| `key_type`                 | String           | `1` (RSA)                              | Corresponds to GPG option: Key-Type (RSA or DSA)                                                           |
| `key_length`               | String           | `2048`                                 | Corresponds to GPG option: Key-Length (2048 or 4096)                                                       |
| `name_real`                | String           | Chef Generated Default (#{batch_name}) | Corresponds to GPG option: Name-Real                                                                       |
| `name_comment`             | String           | generated by Chef                      | Corresponds to GPG option: Name-Comment                                                                    |
| `name_email`               | String           | #{node.name}@example.com               | Corresponds to GPG option: Name-Email                                                                      |
| `expire_date`              | String           | 0                                      | Corresponds to GPG option: Expire-Date.                                                                    |
| `home_dir`                 | String           | ~#{user}/.gnupg                        | Location to store the keyring. Defaults to ~/.gnupg                                                        |
| `batch_config_file`        | String           | gpg_batch_config_#{batch_name}         | Batch config file name                                                                                     |
| `passphrase`               | String           |                                        | Passphrase for key                                                                                         |
| `key_file`                 | String           |                                        | Keyfile name                                                                                               |
| `key_fingerprint`          | String           |                                        | Key finger print. Used to identify when deleting keys using the :delete action                             |
| `pinentry_mode`            | [String, false]  | `loopback` if Ubuntu or False          | Pinentry mode. Set to loopback on Ubuntu and False (off) for all other platforms.                          |
| `batch`                    | [true, false]    | true                                   | Turn batch mode on or off when genrating keys                                                              |

## Actions

- `:generate` (default)
- `:import` Imports from a key file
- `:export` Exports a key file
- `:delete_public_key`
- `:delete_secret_keys`
