#!/usr/bin/env ruby
require 'mixlib/shellout'
require 'git'
require 'logger'

git_log = Mixlib::ShellOut.new("git --no-pager log -1").run_command
cookbook = File.read("#{Dir.pwd}/metadata.rb").split("\n").select{|l|l.start_with?("name")}.first.split.last.gsub("\"","").gsub("'","")
cookbook_directory = Dir.pwd

case git_log.stdout
when /patch/
  release_type='patch'
when /minor/
  release_type='minor'
when /major/
  release_type='major'
end

def welcome_message(c, r)
  puts "Releasing: #{c}"
  puts "Increasing by a #{r} version"
end

def spork_cookbook(c, r)
  spork = Mixlib::ShellOut.new("knife spork bump #{c} #{r} --skip-dependencies")
  spork.run_command
  return spork
end

# Check for version number in CHANGELOG
def update_changelog(cookbook_directory, new_version)
  changelog_file = "#{cookbook_directory}/CHANGELOG.md"
  date = Time.now()
  date.strftime("%Y-%m-%d")
  new_contents = File.read(changelog_file).gsub(/Unreleased/,"\\1#{new_version} #{date}\\2")
  File.open(changelog_file, 'w'){|f| f.write(new_contents)}
end

def commit_update(v)
  g = Git.open(Dir.pwd, :log => Logger.new(STDOUT))
  g.add(['metadata.rb','CHANGELOG.md'])
  g.commit("Release #{v}")
  # g.push
end

# welcome_message(cookbook, release_type)
# spork = spork_cookbook(cookbook, release_type)
# version = spork.stderr.gsub("Successfully bumped #{cookbook} to v","")
# version.chop
# update_changelog(cookbook_directory, version)
# commit_update(version)

# puts spork.stderr


def supermarket_upload(c)
  supermarket = Mixlib::ShellOut.new("knife supermarket share #{c}")
  supermarket.run_command
  return supermarket
end

upload = supermarket_upload(cookbook)
puts "STDOUT: #{upload.stdout}"
puts "STDERR: #{upload.stderr}"
